VERSION 5.00
Begin VB.Form MainForm 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Area Tooltip"
   ClientHeight    =   2295
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4230
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2295
   ScaleWidth      =   4230
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton ExitButton 
      Cancel          =   -1  'True
      Caption         =   "E&xit"
      Height          =   375
      Left            =   3000
      TabIndex        =   1
      Top             =   1800
      Width           =   1095
   End
   Begin VB.PictureBox DrawingArea 
      Appearance      =   0  'Flat
      BackColor       =   &H00FFC0C0&
      ForeColor       =   &H80000008&
      Height          =   1575
      Left            =   120
      ScaleHeight     =   1545
      ScaleWidth      =   2745
      TabIndex        =   0
      Top             =   120
      Width           =   2775
   End
End
Attribute VB_Name = "MainForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'********************************************************************************
'* VXPLib example
'*
'* Area Tooltip
'*
'* Last Modified on 24/03/2003
'*
'* This example is intellectual property of Vitaly Tomilov
'*********************************************************************************

'This example illustrates how to attach a tooltip to any part of a visual element,
'such as part of a window.
'In this example we draw a cross in the middle of a picture box to have four quarters
'in it, and then attach a different tooltip to each quarter.
'
'Note: When attaching tooltips this way the value of the TraceMode flag is always
'ignored, and the tooltip gets hidden just as the mouse cursor moves.

'Declaring two API functions for drawing:
Private Declare Sub LineTo Lib "Gdi32" (ByVal hDC As Long, ByVal xPos As Long, ByVal yPos As Long)
Private Declare Sub MoveToEx Lib "Gdi32" (ByVal hDC As Long, ByVal xPos As Long, ByVal yPos As Long, ByVal rect As Long)

'Declaring an instance of a Tooltip Manager
Private WithEvents manager As VXPTooltipManager
Attribute manager.VB_VarHelpID = -1

Private Sub ExitButton_Click()
'Unloading the form
Unload MainForm
End Sub

Private Sub DrawingArea_Paint()
'Painting a cross in the middle of the picture box:
Dim W, H As Integer
With DrawingArea
    W = ScaleX(.Width, vbTwips, vbPixels)
    H = ScaleY(.Height, vbTwips, vbPixels)
    MoveToEx .hDC, 0, H / 2, 0
    LineTo .hDC, W, H / 2
    MoveToEx .hDC, W / 2, 0, 0
    LineTo .hDC, W / 2, H
End With
End Sub

Private Sub Form_Load()

'Creating a new instance of the Tooltip Manager:
Set manager = New VXPTooltipManager

'Adding two tooltips to the standard visual elements:
manager.windows.Add hWnd, "<body bgcolor=lightsalmon gfc=skyblue><b>Area Tooltips</b><br>This example shows how to attach a tooltip<br>to an area within a window. For each drawn<br>quarter we can see a different tooltip."
manager.windows.Add ExitButton.hWnd, "<body bgcolor=palegreen gfc=yellow>E<u>x</u>it the <i><font color=blue>Area Tooltip</font></i><br>application. <b>Alt+F4</b>"

'Telling the Tooltip Manager to display tooltips just after
'having been only 0.3 second over an object:
manager.ShowDelay = 300

End Sub

Private Sub Form_Paint()
'Here we fill the form with gradient background:
    manager.tool.html.GradientFillRect hDC, RGB(255, 150, 150), RGB(255, 255, 150), 0, 0, ScaleX(Width, vbTwips, vbPixels), ScaleY(Height, vbTwips, vbPixels) - 25
End Sub

'This is the key method, which is an event fired by the Tooltip Manager.
'The event is fired for any window that doesn't have a tooltip attached to it,
'and for which it is time to show a tooltip.
'If an application wants to show a tooltip it has to set parameter Text to an html contents:
Private Sub manager_OnActivateCustomTooltip(ByVal hWnd As Long, ByVal ClassName As String, ByVal x As Integer, ByVal y As Integer, Text As String)
Dim W, H As Integer
If hWnd = DrawingArea.hWnd Then 'If this is the window of our interest
    Dim AtClause As String
    
    'Formatting extra information about mouse cursor position relative to the window:
    AtClause = "<br>x =<font color=blue weight=700>" + Str(x) + "</font>, y =<font color=blue weight=700>" + Str(y) + "</font>"
    
    With DrawingArea
        W = ScaleX(.Width, vbTwips, vbPixels)
        H = ScaleY(.Height, vbTwips, vbPixels)
        If x > W / 2 And y > H / 2 Then 'If right bottom quarter
            Text = "<body bgcolor=white gfc=yellow grad=vert><b>Right Bottom</b>" + AtClause
        Else
            If x < W / 2 And y > H / 2 Then 'If left bottom quarter
                Text = "<body bgcolor=white gfc=pink grad=vert><b>Left Bottom</b>" + AtClause
            Else
                If x < W / 2 And y < H / 2 Then 'If left top quarter
                    Text = "<body bgcolor=white gfc=palegreen grad=vert><b>Left Top</b>" + AtClause
                Else 'Right top quarter
                    Text = "<body bgcolor=white gfc=deeppink grad=vert><b>Right Top</b>" + AtClause
                End If
            End If
        End If
    End With
End If
End Sub
