VERSION 5.00
Begin VB.Form MainForm 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "VXPLib - <DOC> tag example"
   ClientHeight    =   2580
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2580
   ScaleWidth      =   4680
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.Label Label1 
      BackStyle       =   0  'Transparent
      Caption         =   "Hold still the mouse cursor over this form for just a moment to cause the tooltip to appear."
      Height          =   915
      Left            =   960
      TabIndex        =   0
      Top             =   840
      Width           =   2565
   End
End
Attribute VB_Name = "MainForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'****************************************************************
'* VXPLib example
'*
'* Using tag <doc> - virtual document
'*
'* Last Modified on 24/03/2003
'*
'* This example is intellectual property of Vitaly Tomilov
'****************************************************************

'This example illustrates the use of virtual documents through tag <doc>.
'All parameters and functionality of this tag are explained in the QHTML specification.
'Run this example, and hover the mouse cursor over the main window to bring up the
'only tooltip managed in this application.

Private WithEvents manager As VXPTooltipManager
Attribute manager.VB_VarHelpID = -1
'Note: Global variable html was declared only because this is the only way to make
'VB6 see the list of events that can be handled for this particular interface
Private WithEvents html As VXPQuickHTML
Attribute html.VB_VarHelpID = -1
'Declaring Windows API functions for drawing
Private Declare Sub LineTo Lib "Gdi32" (ByVal hDC As Long, ByVal xPos As Long, ByVal yPos As Long)
Private Declare Sub MoveToEx Lib "Gdi32" (ByVal hDC As Long, ByVal xPos As Long, ByVal yPos As Long, ByVal rect As Long)
Private Declare Sub Ellipse Lib "Gdi32" (ByVal hDC As Long, ByVal nLeftRect As Long, ByVal nTopRect As Long, ByVal nRightRect As Long, ByVal nBottomRect As Long)
Private Sub Form_Load()
On Error GoTo ErrorHandler
'Creating a new instance of the tooltip manager
Set manager = New VXPTooltipManager

With manager

    'Selecting the instance of the tooltip manager's html object
    Set html = .tool.html

    'Adding a tooltip and attaching it to the main window of the application
    'Note: the key element in the string for this example is '<doc bgcolor=red border=2 bordercolor=lightgreen>'
    .windows.Add hWnd, "<body bgcolor=darkblue gfc=skyblue grad=vert><font color=white>This example illustrates a virtual document" _
    & "<br>that draws its contents as a simple circle<br>with two criss-crossed lines:</font><br><table><tr><td>" _
    & "<doc bgcolor=red border=2 bordercolor=lightgreen gfc=yellow grad=vert></td><td align=center valign=middle><font color=yellow>" _
    & "You can draw a document<br>of any complexity</td></tr></table>"

    .tool.BorderColor = RGB(255, 0, 0) 'Setting red color for the tooltip border
    .tool.FadeShow = 1000 'The tooltip must appear completely within 1 second
    .ShowDelay = 100 'The tooltip must be shown after being just 0.1 second over the object
    
End With

GoTo Success

ErrorHandler:
MsgBox "Cannot run the example. VXPLib.dll needs to be registered on your PC first."
Unload MainForm

Success:
End Sub

Private Sub Form_Paint()
'Here we fill the form with gradient background:
    manager.tool.html.GradientFillRect hDC, RGB(255, 200, 200), RGB(255, 255, 200), 0, 0, ScaleX(Width, vbTwips, vbPixels), ScaleY(Height, vbTwips, vbPixels) - 25
End Sub

Private Sub Form_Unload(Cancel As Integer)
'Releasing the html object instance reference
Set html = Nothing
'Releasing the tooltip manager instance reference
Set manager = Nothing
End Sub

'Because we do not specify Width and Height right in the tag we have to set them to a value
'different from 0 inside this event handler. If we do not do this, the document tag will be
'ignored and the document won't be drawn (OnDocumentDraw won't be called).
'Alternative to handling this event would be specifying attributes WIDTH and HEIGHT right in the <DOC> tag.
Private Sub html_OnDocumentGetSize(ByVal DocumentPath As String, ByVal Param As String, Width As Integer, Height As Integer)

Width = 80
Height = 80

End Sub
' Note: It is responsibility of the developer not to draw anything outside
' rectangle {X, Y, X + Width, Y + Height}. All drawing coordinates in this
' example are used with this in view. And it is the only reason why {X, Y} are
' also passed as parameters.
Private Sub html_OnDocumentDraw(ByVal DocumentPath As String, ByVal Param As String, ByVal DC As Long, ByVal X As Integer, ByVal Y As Integer, ByVal W As Integer, ByVal H As Integer)

'In this example we just draw a simple picture to give developers an idea of how a more
'complicated drawing can be done:
Ellipse DC, X, Y, X + 80, Y + 80    'Drawing a circle
MoveToEx DC, X + 12, Y + 12, 0      'Moving the drawing cursor coordinates
LineTo DC, X + 68, Y + 68           'Drawing the first line
MoveToEx DC, X + 68, Y + 12, 0      'Moving the drawing cursor coordinates
LineTo DC, X + 12, Y + 68           'Drawing the second line

End Sub

