VERSION 5.00
Begin VB.Form MainForm 
   Caption         =   "Advanced Menus"
   ClientHeight    =   1740
   ClientLeft      =   165
   ClientTop       =   795
   ClientWidth     =   6615
   LinkTopic       =   "Form1"
   ScaleHeight     =   1740
   ScaleWidth      =   6615
   StartUpPosition =   2  'CenterScreen
   WhatsThisHelp   =   -1  'True
   Begin VB.CheckBox HideSave 
      Caption         =   "Hide Menu ""Save"""
      Height          =   375
      Left            =   3120
      TabIndex        =   3
      Top             =   840
      Width           =   1815
   End
   Begin VB.CheckBox CustomMenuBarColor 
      Caption         =   "Override menu palette with pastel colors"
      Height          =   375
      Left            =   3120
      TabIndex        =   2
      Top             =   120
      Width           =   3135
   End
   Begin VB.CheckBox DisableOpen 
      Caption         =   "Disable item ""Open Project"""
      Height          =   375
      Left            =   3120
      TabIndex        =   1
      Top             =   480
      Width           =   2415
   End
   Begin VB.CheckBox TransparentMenus 
      Caption         =   "Transparent menu"
      Height          =   375
      Left            =   3120
      TabIndex        =   0
      Top             =   1200
      Width           =   1815
   End
   Begin VB.Menu FileMenu 
      Caption         =   "&File"
      NegotiatePosition=   3  'Right
      Begin VB.Menu Caption 
         Caption         =   "-"
      End
      Begin VB.Menu FileNew 
         Caption         =   "New"
      End
      Begin VB.Menu FileOpen 
         Caption         =   "Open"
      End
      Begin VB.Menu FileSave 
         Caption         =   "Save"
      End
      Begin VB.Menu sep2 
         Caption         =   "-"
      End
      Begin VB.Menu FilePrint 
         Caption         =   "Print"
      End
      Begin VB.Menu FilePrintPreview 
         Caption         =   "PrintPreview"
      End
      Begin VB.Menu sep3 
         Caption         =   "-"
      End
      Begin VB.Menu FileExit 
         Caption         =   "Exit"
      End
      Begin VB.Menu fileFooter 
         Caption         =   "-"
      End
   End
   Begin VB.Menu HelpMenu 
      Caption         =   "&Help"
      Begin VB.Menu something 
         Caption         =   "&About Advanced Menus"
      End
   End
End
Attribute VB_Name = "MainForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'///////////////////////////////////////////////////////////////////////////////////
'// VXPLib example
'//
'// Advanced Menus
'//
'// Last Modified on 10/06/2003
'//
'// This example is intellectual property of Tooltips.NET L.L.C.
'//
'// For details visit www.Tooltips.NET
'///////////////////////////////////////////////////////////////////////////////////

'This example illustrates advanced drawing features using
'interfaces VXPMenuHook and VXPQuickHTML:

' - Overrides menus to be ownerdrawn, then measures and draws those menu items
' - Uses XP style for selecting menu items
' - Uses program resources to store HTML contents for drawing menu items
' - Draws custom menu separators using tag <HR>
' - Draws menu caption and footer as overridden menu separators
' - Overrides menu items on the menu bar, and draws them using XP selection.
' - Overrides pallette of the whole menu
' - Shows how to draw on the menu bar extender + (new!!!) fill it with gradient
' - Shows how to draw disabled menu items

'Declaring a menu hook:
Private WithEvents menu As VXPMenuHook
Attribute menu.VB_VarHelpID = -1

'Declaring all the menu items:
Private fNew As New VXPQuickHTML
Attribute fNew.VB_VarHelpID = -1
Private fOpen As New VXPQuickHTML
Attribute fOpen.VB_VarHelpID = -1
Private fSave As New VXPQuickHTML
Attribute fSave.VB_VarHelpID = -1
Private fPrint As New VXPQuickHTML
Attribute fPrint.VB_VarHelpID = -1
Private fPreview As New VXPQuickHTML
Attribute fPreview.VB_VarHelpID = -1
Private fExit As New VXPQuickHTML
Attribute fExit.VB_VarHelpID = -1
Private fSeparator As New VXPQuickHTML
Private fCaption As New VXPQuickHTML
Private fFooter As New VXPQuickHTML
Private fFile As New VXPQuickHTML
Private fHelp As New VXPQuickHTML
Private fAbout As New VXPQuickHTML
Private fExtender As New VXPQuickHTML

'Declaring menu item ID-s to be used for menu items
'for easier access. We found these values using tooltips
'in debug mode. For caption items we just calculated them
Const fHelpID = 1
Const fCaptionID = 2
Const fNewID = 3
Const fOpenID = 4
Const fSaveID = 5
Const fSeparator1ID = 6
Const fPrintID = 7
Const fPreviewID = 8
Const fSeparator2ID = 9
Const fExitID = 10
Const fFooterID = 11
Const fFileID = 12
Const fAboutID = 13

'In practice it is suggested to use the standard windows palette to draw menus,
'even though this interface allows to modify the colors, because it is best to
'leave the user to decide what colors are to be used for all menus in the system
Private Sub CustomMenuBarColor_Click()
If CustomMenuBarColor = 1 Then
    'Set up some sort of a Pastel palette:
    menu.capColor = RGB(255, 220, 220) 'Pink Color
    menu.selColor = RGB(0, 200, 0) 'Green Color
    menu.bgColor = RGB(255, 255, 220) 'Yellow Color
Else
    menu.ResetPalette 'Restoring colors from the windows system palette
End If
menu.DrawMenuBar 'Updating the menu bar appearance
End Sub

Private Sub DisableOpen_Click()
If DisableOpen = 1 Then
    FileOpen.Enabled = False
Else
    FileOpen.Enabled = True
End If
End Sub

Private Sub Form_Load()

'Creating a new instance of the VXPMenuHook object:
Set menu = New VXPMenuHook

'We need to draw all items using transparency:
fNew.Transparent = True
fOpen.Transparent = True
fSave.Transparent = True
fPrint.Transparent = True
fPreview.Transparent = True
fExit.Transparent = True
fSeparator.Transparent = True
fFile.Transparent = True
fHelp.Transparent = True
fAbout.Transparent = True
fExtender.Transparent = True

'Setting contents for all menu item drawing objects.
'Tag <TXT RES='QHTML:ResName'> will be taking contents
'from the program's resources using resource name ResName
'of type QHTML.
'Note: When using resource type HTML the parser (VXPQuickHTML)
'will try to locate the real HTML resource, but since VB6 doesn't
'support HTML type of resources we had to use a different name (QHTML):
fNew.SetSourceText "<txt res='qhtml:new'>"
fOpen.SetSourceText "<txt res='qhtml:open'>"
fSave.SetSourceText "<txt res='qhtml:save'>"
fPrint.SetSourceText "<txt res='qhtml:print'>"
fPreview.SetSourceText "<txt res='qhtml:preview'>"
fExit.SetSourceText "<txt res='qhtml:exit'>"
fSeparator.SetSourceText "<txt res='qhtml:separator'>"
fCaption.SetSourceText "<txt res='qhtml:caption'>"
fFooter.SetSourceText "<txt res='qhtml:footer'>"
fFile.SetSourceText "<txt res='qhtml:folder'>"
fHelp.SetSourceText "<txt res='qhtml:help'>"
fAbout.SetSourceText "<txt res='qhtml:about'>"
fExtender.SetSourceText "<txt res='qhtml:extender'>"

'Now this is a tricky way to find out whether the program is running
'as an EXE file, or from VB environment.
'If it is VB environment, then the resource will fail to load,
'and output size for all HTML objects will be 0
If fExit.Height = 0 Then
    MsgBox "This demo program works with VB resources, which cannot be accessed, if run from VB environment." + Chr(13) + "Make an EXE file of this project, and then run that file from Windows Explorer.", vbExclamation + vbOKOnly, "Advanced Menus: Can't run from VB environment!"
    Unload MainForm
Else
    menu.HookWnd hWnd 'Attaching the menu hook to the form
End If

'Overriding items in the menu bar:
menu.Override 0, True, fFileID 'Overriding item "File"
menu.Override 1, True, fHelpID 'Overriding item "Help"

'Telling the menu hook interface that item with ID fHelpID is our so-called Menu Bar Extender,
'which means that this item's background color is to be used to draw over the whole right section
'of the menu bar that is empty, and additionally, for that area will be called event OnDrawMenuBarExtender
'to allow the client application to draw whatever it wants in the area not occupied by menu items.
'Note: Only the last menu item on the menu bar can be the menu bar extender!
menu.MenuBarExtenderID = fHelpID

End Sub

Private Sub FileExit_Click()
Unload MainForm 'Quitting the application
End Sub

Private Sub Form_Resize()
'Updating the menu bar whenever the form is resized, because we can use a custom color for the menu bar,
'and to fire event OnDrawMenuBarExtender again to reposition the drawing correctly:
If CustomMenuBarColor = 1 Then 'If we override the system palette
    menu.DrawMenuBar                'Update the menu
End If
End Sub

Private Sub DrawItem(ByVal hDC As Long, ByVal item As VXPQuickHTML, ByVal X As Integer, ByVal Y As Integer, ByVal Flags As VXPLibrary.VXPMenuItemFlags, ByVal ItemID As Long)
    If ItemID <> fSeparator1ID And ItemID <> fSeparator2ID And ItemID <> fCaptionID And ItemID <> fFooterID And (Flags And mfDisabled) Then
        item.DrawState hDC, X, Y, dssDisabled
    Else
        item.Draw hDC, X, Y
    End If
End Sub

Private Sub HideSave_Click()
If HideSave = 1 Then
    FileSave.Visible = False
Else
    FileSave.Visible = True
End If
End Sub

Private Sub menu_OnDrawItem(ByVal hMenu As Long, ByVal hDC As Long, ByVal ItemID As Long, ByVal Flags As VXPLibrary.VXPMenuItemFlags, ByVal X As Integer, ByVal Y As Integer, ByVal W As Integer, ByVal H As Integer)

'Drawing the item's background:
If ItemID <> fSeparator1ID And ItemID <> fSeparator2ID And ItemID <> fCaptionID And ItemID <> fFooterID Then  'If not separator, caption or footer
        menu.DrawItemBackground True
End If

'Drawing all items in the menu:
Select Case ItemID
    Case fNewID
        DrawItem hDC, fNew, X, Y, Flags, ItemID
    Case fOpenID
        DrawItem hDC, fOpen, X, Y, Flags, ItemID
    Case fSaveID
        DrawItem hDC, fSave, X, Y, Flags, ItemID
    Case fPrintID
        DrawItem hDC, fPrint, X, Y, Flags, ItemID
    Case fPreviewID
        DrawItem hDC, fPreview, X, Y, Flags, ItemID
    Case fExitID
        DrawItem hDC, fExit, X, Y, Flags, ItemID
    Case fCaptionID
        DrawItem hDC, fCaption, X, Y, Flags, ItemID
    Case fFooterID
        DrawItem hDC, fFooter, X, Y, Flags, ItemID
    Case fSeparator1ID
        DrawItem hDC, fSeparator, X, Y, Flags, ItemID
    Case fSeparator2ID
        DrawItem hDC, fSeparator, X, Y, Flags, ItemID
    Case fAboutID
        DrawItem hDC, fAbout, X, Y, Flags, ItemID
    Case fFileID
        fFile.Draw hDC, X + 5, Y + 2 'This is an absolute {5, 2} offset for better looking of the menu items
    Case fHelpID
        fHelp.Draw hDC, X + 5, Y + 2 'This is an absolute {5, 2} offset for better looking of the menu items
End Select
End Sub

Private Sub menu_OnDrawMenuBarExtender(ByVal hDC As Long, ByVal X As Integer, ByVal Y As Integer, ByVal W As Integer, ByVal H As Integer)

'Filling the menu bar with gradient.
'The StartColor parameter is the same as menu.capColor to achieve smooth color change.
'Note: we can use any instance of VXPQuickHTML, because method GradientFillRect is not
'bound to QHTML documents.
If W > 0 And CustomMenuBarColor = 1 Then
    fNew.GradientFillRect hDC, RGB(255, 220, 220), RGB(150, 255, 150), X, Y, X + W, Y + H
End If

If fExtender.Width < W Then 'If our drawn object can fit into the empty menu bar area
    fExtender.Draw hDC, X + W - fExtender.Width, Y + 1 'Drawing our menu bar extender document
End If
End Sub

'This event must set dimensions of all menu items:
Private Sub menu_OnMeasureItem(ByVal ItemID As Long, ItemWidth As Integer, ItemHeight As Integer)
Select Case ItemID
Case fNewID
    ItemWidth = fNew.Width
    ItemHeight = fNew.Height
Case fOpenID
    ItemWidth = fOpen.Width
    ItemHeight = fOpen.Height
Case fSaveID
    ItemWidth = fSave.Width
    ItemHeight = fSave.Height
Case fPrintID
    ItemWidth = fPrint.Width
    ItemHeight = fPrint.Height
Case fPreviewID
    ItemWidth = fPreview.Width
    ItemHeight = fPreview.Height
Case fExitID
    ItemWidth = fExit.Width
    ItemHeight = fExit.Height
Case fSeparatorID
    ItemWidth = 0
    ItemHeight = fSeparator.Height
Case fFooterID
    ItemWidth = 0
    ItemHeight = fFooter.Height
Case fCaptionID
    ItemWidth = 0
    ItemHeight = fCaption.Height
Case fFileID
    ItemWidth = fFile.Width
    ItemHeight = 0
Case fHelpID
    ItemWidth = fHelp.Width
    ItemHeight = 0
Case fAboutID
    ItemWidth = fAbout.Width
    ItemHeight = fAbout.Height
End Select
End Sub
'Called when menu is initialized, and is the best
'place to override all menu items:
Private Sub menu_OnMenuInit(ByVal hMenu As Long, ByVal ItemPos As Integer, ByVal IsWindowMenu As Boolean)
If IsWindowMenu Then
    menu.Override 0, True, 0, 0
    menu.Override 1, True, 0, 0
    menu.Override 2, True, 0, 0
    menu.Override 3, True, 0, 0
    menu.Override 4, True, 0, 0
    menu.Override 5, True, 0, 0
    menu.Override 6, True, 0, 0
    menu.Override 7, True, 0, 0
    menu.Override 8, True, 0, 0
    menu.Override 9, True, 0, 0
    menu.Override 0, True, 0, 1
End If
End Sub

Private Sub TransparentMenus_Click()
If TransparentMenus = 1 Then
    menu.MenuTransparency = 200
Else
    menu.MenuTransparency = 255
End If
End Sub
