VERSION 5.00
Begin VB.Form MainForm 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Context Menus"
   ClientHeight    =   6090
   ClientLeft      =   150
   ClientTop       =   660
   ClientWidth     =   6600
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   6090
   ScaleWidth      =   6600
   StartUpPosition =   2  'CenterScreen
   WhatsThisHelp   =   -1  'True
   Begin VB.Menu FileMenu 
      Caption         =   "&File"
      NegotiatePosition=   3  'Right
      Begin VB.Menu FileExit 
         Caption         =   "Exit"
      End
   End
   Begin VB.Menu menuContext 
      Caption         =   "Context Menus"
      Visible         =   0   'False
      Begin VB.Menu contextNew 
         Caption         =   "&New"
      End
      Begin VB.Menu contextOpen 
         Caption         =   "&Open"
      End
      Begin VB.Menu contextSave 
         Caption         =   "&Save"
      End
      Begin VB.Menu contextTip 
         Caption         =   "&Tip"
      End
   End
End
Attribute VB_Name = "MainForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'*************************************************************
'* VXPLib example
'*
'* Context Menus
'*
'* Last Modified on 21/12/2002
'*
'* This example is an intellectual property of Vitaly Tomilov
'*
'* For details visit www.tooltips.net
'*************************************************************

'This example illustrates overriding a context menu by using
'interfaces VXPMenuHook and VXPQuickHTML. Interface VXPTooltipManager
'is used for attaching a tooltip to the "Tip of the day" item,
'and the main form.

'Totally, the example does the following:

' - Overrides items of a context menu to be ownerdrawn, then measures and draws those menu items
' - Uses XP style for selecting menu items
' - Uses program resources to store HTML contents for drawing menu items
' - Draws a "Tip of the day" item using a special background for unselected state,
'   and special color for selected state. This is to show that menu items can be selected using
'   different colors.
' - Attaches a tooltip to the main form and the "Tip of the day" item.

'Declaring a menu hook:
Private WithEvents menu As VXPMenuHook
Attribute menu.VB_VarHelpID = -1

'Tooltip Manager:
Private manager As New VXPTooltipManager

'Declaring all the menu items:
Private fNew As New VXPQuickHTML
Attribute fNew.VB_VarHelpID = -1
Private fOpen As New VXPQuickHTML
Attribute fOpen.VB_VarHelpID = -1
Private fSave As New VXPQuickHTML
Attribute fSave.VB_VarHelpID = -1
Private fTip As New VXPQuickHTML
Private fTipSel As New VXPQuickHTML

'Declaring menu item ID-s to be used for menu items
'for easier access:
Const fNewID = 101
Const fOpenID = 102
Const fSaveID = 103
Const fTipID = 104

'This logical variable is to indicate when it is time to override
'menu items (see OnMenuInit(...))
Private popup As Boolean

Private Sub Form_Load()

'Creating a new instance of the VXPMenuHook object:
Set menu = New VXPMenuHook

popup = False

'We need to draw all items using transparency:
fNew.Transparent = True
fOpen.Transparent = True
fSave.Transparent = True
fTipSel.Transparent = True

'Setting contents for all menu item drawing objects.
'Tag <TXT RES='QHTML:ResName'> will be taking contents
'from the program's resources using resource name ResName
'of type QHTML.
'Note: When using resource type HTML the parser (VXPQuickHTML)
'will try to locate the real HTML resource, but since VB6 doesn't
'support HTML type of resources we had to use a custom name (QHTML):
fNew.SetSourceText "<txt res='qhtml:new'>"
fOpen.SetSourceText "<txt res='qhtml:open'>"
fSave.SetSourceText "<txt res='qhtml:save'>"
fTip.SetSourceText "<txt res='qhtml:tip'>"
fTipSel.SetSourceText "<txt res='qhtml:tip_sel'>"

manager.windows.Add hWnd, "<body bgcolor=lightsalmon><b>Context Menus</b><br>This demo program shows how to override<br>a context menu in a VB application<hr><table><tr><td><img res='gif:tip'></td><td><font color=darkblue><u>Right mouse click</u> on the form to bring<br>up the context menu of the form.</td></tr></table>"
manager.commands.Add fTipID, "<b>Tip of the day</b><br>This tooltip could display here some information<br>about the menu, or any appropriate context,<br>and then add something like this:<hr color=darkred><font color=blue weight=700><img res='gif:tip'>&#32;Click on this menu item to learn<br>more about how to use this...&#32;&#32;<img res='gif:arrow'></font>"
manager.UseMenuItemID = True 'Bind tooltips to menu item ID-s instead of Commands ID-s

'Because context menus are not bound to their owner as
'the parent window, we have to tell the Tooltip Manager
'explicitly what window actually owns the menu:
manager.UpdateContextMenuOwner hWnd

'Now this is a tricky way to find out whether the program is running
'as an EXE file, or from VB environment.
'If it is VB environment, then the resource will fail to load,
'and output size for all HTML objects will be 0
If fNew.Height = 0 Then
    MsgBox "This demo program works with VB resources, which cannot be accessed, if run from VB environment." + Chr(13) + "Make an EXE file of this project, and then run that file from Windows Explorer.", vbExclamation + vbOKOnly, "Context Menus: Can't run from VB environment!"
    Unload MainForm
Else
    menu.HookWnd hWnd 'Attaching the menu hook to the form
End If
End Sub

Private Sub FileExit_Click()
Unload MainForm
End Sub

Private Sub menu_OnContextMenu(ByVal hWnd As Long, ByVal x As Integer, ByVal y As Integer)
popup = True
PopupMenu menuContext
popup = False
End Sub

Private Sub menu_OnDrawItem(ByVal hMenu As Long, ByVal hDC As Long, ByVal ItemID As Long, ByVal Flags As VXPLibrary.VXPMenuItemFlags, ByVal x As Integer, ByVal y As Integer, ByVal W As Integer, ByVal H As Integer)

'Changing selection color for item "Tip of the day"
If ItemID = fTipID Then
    menu.selColor = RGB(255, 0, 0)
End If

'Drawing the item's background:
menu.DrawItemBackground True

'Restoring selection color for item "Tip of the day"
If ItemID = fTipID Then
    menu.ResetPalette
End If

'Drawing all items in the menu:
Select Case ItemID
    Case fNewID
        fNew.Draw hDC, x, y
    Case fOpenID
        fOpen.Draw hDC, x, y
    Case fSaveID
        fSave.Draw hDC, x, y
    Case fTipID
        If Flags And mfHiLite Then
            fTipSel.Draw hDC, x, y
        Else
            fTip.Draw hDC, x, y
        End If
End Select
End Sub

'This event must set dimensions of all menu items:
Private Sub menu_OnMeasureItem(ByVal ItemID As Long, ItemWidth As Integer, ItemHeight As Integer)
Select Case ItemID
Case fNewID
    ItemWidth = fNew.Width
    ItemHeight = fNew.Height
Case fOpenID
    ItemWidth = fOpen.Width
    ItemHeight = fOpen.Height
Case fSaveID
    ItemWidth = fSave.Width
    ItemHeight = fSave.Height
Case fTipID
    ItemWidth = 0
    ItemHeight = fTip.Height
End Select
End Sub
'Called when menu is initialized, and is the best
'place to override all menu items:
Private Sub menu_OnMenuInit(ByVal hMenu As Long, ByVal ItemPos As Integer, ByVal IsWindowMenu As Boolean)
If popup Then
    menu.OverrideMenu hMenu, 0, True, fNewID
    menu.OverrideMenu hMenu, 1, True, fOpenID
    menu.OverrideMenu hMenu, 2, True, fSaveID
    menu.OverrideMenu hMenu, 3, True, fTipID
End If
End Sub

Private Sub contextTip_Click()
MsgBox "You can display some useful information here.", vbOKOnly + vbInformation, "Tip of the day"
End Sub

